#include <stdio.h>
#include <stdlib.h>
#include <dirent.h>
#include <unistd.h>
#include <string.h>
#include <ctype.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <gtk/gtk.h>

#include "callbacks.h"
#include "config.h"
#include "interface.h"
#include "support.h"
#include "system.h"
#include "ux.h"
char *uxexe;
float uxlen=0;
void uxCompress(char *saveas){
  errMessage=create_dlgMessage();
  txtMessage=lookup_widget(errMessage,"txtMessage");
  if(methods.ux.Intern==1)
	internUx(saveas);
  else
	externUx(saveas);
}

void uxParseOptions(){
  char *temp;
  uxexe=(char*)malloc(2048);
  memset(uxexe,0x0,sizeof(uxexe));
//  strcpy(uxexe,methods.ux.Exe);
//  strcpy(uxexe,"-");
  temp=(char*)malloc(sizeof(temp));
  sprintf(temp,"-b %d",methods.ux.CompLevel);
  strcat(uxexe,temp);
  free(temp);
/*  if(methods.ux.RecThru==1)
	strcat(uxexe,"r");Only on Internal UxCompress*/
}

void externUx(char *saveas){
  FILE *fp;
  char *buffer,*exe[8194];
  char temp2[256];
  int status=0;
  float nums=0,size=0;
  nums=selTo->numrows;
  gdk_threads_enter();
  lstTo=lookup_widget(winMain,"lstTo");
  for(uxlen=0;;uxlen++){
	if(cancelled==1)
	  break;
	if(gtk_clist_get_text(GTK_CLIST(lstTo),uxlen,0,&buffer)==0)
  	  break;
  	else{
  	  fp=fopen(buffer,"r");
  	  fseek(fp,0L,SEEK_END);
  	  size=ftell(fp);
  	  fclose(fp);
	  gtk_progress_configure(GTK_PROGRESS(lookup_widget(Progress,"pgsCurrentFile")),0,0,size);
  	  gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsCurrentFile")),size/5);
  	  while(gtk_events_pending())
    	    gtk_main_iteration();
  	  uxParseOptions();
  	  gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsCurrentFile")),size/4);
  	  while(gtk_events_pending())
  	    gtk_main_iteration();
  	  exe[0]=methods.ux.Exe;
  	  gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsCurrentFile")),size/3);
  	  while(gtk_events_pending())
    	    gtk_main_iteration();
	  if(methods.ux.WriteOverOut==1)
		exe[1]="-f";
	  gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsCurrentFile")),size/3);
  	  while(gtk_events_pending())
    	    gtk_main_iteration();
  	  exe[2]=uxexe;
  	  gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsCurrentFile")),size/2);
  	  while(gtk_events_pending())
    	    gtk_main_iteration();
  	  exe[3]=buffer;
    	  gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsCurrentFile")),size/1);
    	  while(gtk_events_pending())
      	    gtk_main_iteration();	
	  status=mySystem(exe);
//	  printf("status %d\n",status);
  	  gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsCurrentFile")),size);
  	  gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsTotalFiles")),uxlen+1);
  	  gtk_label_set_text(GTK_LABEL(lookup_widget(Progress,"lblProgressFileName")),buffer);
  	  memset(temp2,0x0,sizeof(temp2));
  	  sprintf(temp2,"%1.0f of %1.0f done",uxlen+1,nums);
  	  gtk_label_set_text(GTK_LABEL(lookup_widget(Progress,"lblProgressTotalFiles")),temp2);
  	  while(gtk_events_pending())
        gtk_main_iteration();
	}
  }
  if(cancelled==1){
//	printf("Cancelled\n");
	gtk_text_backward_delete(GTK_TEXT(txtMessage),gtk_text_get_length(GTK_TEXT(txtMessage)));
	gtk_text_insert(GTK_TEXT(txtMessage),NULL,NULL,NULL,ERR_MSG08,strlen(ERR_MSG08));
	gtk_widget_show(errMessage);
  }else{
    gtk_widget_hide(lookup_widget(Progress,"btnProgressCancel"));
    gtk_widget_show(lookup_widget(Progress,"btnProgressDone"));
  }
  /*else{
	gtk_progress_set_value(GTK_PROGRESS(lookup_widget(Progress,"pgsTotalFiles")),len+1);
	while(gtk_events_pending())
  	  gtk_main_iteration();	
	gtk_widget_hide(lookup_widget(Progress,"btnProgressCancel"));
	gtk_widget_show(lookup_widget(Progress,"btnProgressClose"));
	gtk_widget_grab_default(lookup_widget(Progress,"btnProgressClose"));*/
//  gtk_clist_remove(GTK_CLIST(lstTo),len);
	gdk_threads_leave();
  //}
}

int internUx(char *saveas){
  return 0;
}  
